Crypto++ 8.2 Free C++ class library of cryptographic schemes

Public Types | Public Member Functions | Static Public Attributes | List of all members
ed25519PublicKey Struct Reference

Ed25519 public key. More...

Inheritance diagram for ed25519PublicKey:

## Public Types
typedef Integer | Element

## Public Member Functions
OID | GetAlgorithmID () const
| Retrieves the OID of the algorithm. More...
void | Save (BufferedTransformation &bt) const
| DER encode ASN.1 object. More...
void | Load (BufferedTransformation &bt)
| BER decode ASN.1 object. More...
void | BERDecode (BufferedTransformation &bt)
| Decode this object from a BufferedTransformation. More...
void | DEREncode (BufferedTransformation &bt) const
| Encode this object into a BufferedTransformation. More...
void | BERDecodePublicKey (BufferedTransformation &bt, bool parametersPresent, size_t size)
| Decode subjectPublicKey part of subjectPublicKeyInfo. More...
void | DEREncodePublicKey (BufferedTransformation &bt) const
| Encode subjectPublicKey part of subjectPublicKeyInfo. More...
void | BERDecodeAndCheckAlgorithmID (BufferedTransformation &bt)
| Determine if OID is valid for this object. More...
bool | Validate (RandomNumberGenerator &rng, unsigned int level) const
| Check this object for errors. More...
bool | GetVoidValue (const char *name, const std::type_info &valueType, void *pValue) const
| Get a named value. More...
void | AssignFrom (const NameValuePairs &source)
| Assign values to this object. More...
void | SetPublicElement (const byte y[PUBLIC_KEYLENGTH])
void | SetPublicElement (const Element &y)
const Element & | GetPublicElement () const
const byte * | GetPublicKeyBytePtr () const
| Retrieve public key byte array. More...
Public Member Functions inherited from X509PublicKey
virtual bool | BERDecodeAlgorithmParameters (BufferedTransformation &bt)
| Decode algorithm parameters. More...
virtual bool | DEREncodeAlgorithmParameters (BufferedTransformation &bt) const
| Encode algorithm parameters. More...
Public Member Functions inherited from ASN1CryptoMaterial< PublicKey >
void | Save (BufferedTransformation &bt) const
| DER encode ASN.1 object. More...
void | Load (BufferedTransformation &bt)
| BER decode ASN.1 object. More...
Public Member Functions inherited from ASN1Object
virtual void | BEREncode (BufferedTransformation &bt) const
| Encode this object into a BufferedTransformation. More...
Public Member Functions inherited from CryptoMaterial
virtual void | ThrowIfInvalid (RandomNumberGenerator &rng, unsigned int level) const
| Check this object for errors. More...
virtual bool | SupportsPrecomputation () const
| Determines whether the object supports precomputation. More...
virtual void | Precompute (unsigned int precomputationStorage)
| Perform precomputation. More...
virtual void | LoadPrecomputation (BufferedTransformation &storedPrecomputation)
| Retrieve previously saved precomputation. More...
virtual void | SavePrecomputation (BufferedTransformation &storedPrecomputation) const
| Save precomputation for later use. More...
void | DoQuickSanityCheck () const
| Perform a quick sanity check. More...
Public Member Functions inherited from NameValuePairs
template<class T >
bool | GetThisObject (T &object) const
| Get a copy of this object or subobject. More...
template<class T >
bool | GetThisPointer (T *&ptr) const
| Get a pointer to this object. More...
template<class T >
bool | GetValue (const char *name, T &value) const
| Get a named value. More...
template<class T >
T | GetValueWithDefault (const char *name, T defaultValue) const
| Get a named value. More...
CRYPTOPP_DLL std::string | GetValueNames () const
| Get a list of value names that can be retrieved. More...
CRYPTOPP_DLL bool | GetIntValue (const char *name, int &value) const
| Get a named value with type int. More...
CRYPTOPP_DLL int | GetIntValueWithDefault (const char *name, int defaultValue) const
| Get a named value with type int, with default. More...
CRYPTOPP_DLL bool | GetWord64Value (const char *name, word64 &value) const
| Get a named value with type word64. More...
CRYPTOPP_DLL word64 | GetWord64ValueWithDefault (const char *name, word64 defaultValue) const
| Get a named value with type word64, with default. More...
template<class T >
void | GetRequiredParameter (const char *className, const char *name, T &value) const
| Retrieves a required name/value pair. More...
CRYPTOPP_DLL void | GetRequiredIntParameter (const char *className, const char *name, int &value) const
| Retrieves a required name/value pair. More...

## Static Public Attributes
static const int | PUBLIC_KEYLENGTH = 32
| Size of the public key. More...

## Additional Inherited Members
Static Public Member Functions inherited from NameValuePairs
static CRYPTOPP_DLL void CRYPTOPP_API | ThrowIfTypeMismatch (const char *name, const std::type_info &stored, const std::type_info &retrieving)
| Ensures an expected name and type is present. More...

## Detailed Description

Ed25519 public key.

ed25519PublicKey is somewhat of a hack. It needed to provide DL_PublicKey interface to fit into the existing framework, but it lacks a lot of the internals of a true DL_PublicKey. The missing pieces include GroupParameters and Point, which provide the low level field operations found in traditional implementations like NIST curves over prime and binary fields.

ed25519PublicKey is also unusual because the class members of interest are byte arrays and not Integers. In addition, the byte arrays are little-endian meaning LSB is at element 0 and the MSB is at element 31. If you call GetPublicElement() then the little-endian byte array is converted to a big-endian Integer() so it can be returned the way a caller expects. And calling SetPublicElement() perfoms a similar internal conversion.

Since
  Crypto++ 8.0

Definition at line 625 of file xed25519.h.

## Member Function Documentation

## ◆ GetAlgorithmID()

OID ed25519PublicKey::GetAlgorithmID | ( |  | ) | const
| inline virtual

Retrieves the OID of the algorithm.

Returns
  OID of the algorithm

Implements X509PublicKey.

Definition at line 632 of file xed25519.h.

## ◆ Save()

void ed25519PublicKey::Save | ( | BufferedTransformation & | bt | ) | const
| inline virtual

DER encode ASN.1 object.

Parameters

  bt | BufferedTransformation object

Save() will write the OID associated with algorithm or scheme. In the case of public and private keys, this function writes the subjectPubicKeyInfo parts.

The default OID is from RFC 8410 using `id-X25519`. The default private key format is RFC 5208, which is the old format. The old format provides the best interop, and keys will work with OpenSSL.

Reimplemented from CryptoMaterial.

Definition at line 645 of file xed25519.h.

## ◆ Load()

void ed25519PublicKey::Load | ( | BufferedTransformation & | bt | ) |
| inline virtual

BER decode ASN.1 object.

Parameters

  bt | BufferedTransformation object

See also
  RFC 5958, Asymmetric Key Packages

Reimplemented from CryptoMaterial.

Definition at line 653 of file xed25519.h.

## ◆ BERDecode()

void ed25519PublicKey::BERDecode | ( | BufferedTransformation & | bt | ) |
| virtual

Decode this object from a BufferedTransformation.

Parameters

  bt | BufferedTransformation object

Uses Basic Encoding Rules (BER)

Reimplemented from X509PublicKey.

Definition at line 753 of file xed25519.cpp.

## ◆ DEREncode()

void ed25519PublicKey::DEREncode | ( | BufferedTransformation & | bt | ) | const
| virtual

Encode this object into a BufferedTransformation.

Parameters

  bt | BufferedTransformation object

Uses Distinguished Encoding Rules (DER)

Reimplemented from X509PublicKey.

Definition at line 767 of file xed25519.cpp.

## ◆ BERDecodePublicKey()

void ed25519PublicKey::BERDecodePublicKey | ( | BufferedTransformation & | bt,
|  | bool | parametersPresent,
|  | size_t | size
| ) |  |
| virtual

Decode subjectPublicKey part of subjectPublicKeyInfo.

Parameters

  bt | BufferedTransformation object
  parametersPresent | flag indicating if algorithm parameters are present
  size | number of octets to read for the parameters, in bytes

BERDecodePublicKey() the decodes subjectPublicKey part of subjectPublicKeyInfo, without the BIT STRING header.

When `parametersPresent = true` then BERDecodePublicKey() calls BERDecodeAlgorithmParameters() to parse algorithm parameters.

See also
  BERDecodeAlgorithmParameters

Implements X509PublicKey.

Definition at line 780 of file xed25519.cpp.

## ◆ DEREncodePublicKey()

void ed25519PublicKey::DEREncodePublicKey | ( | BufferedTransformation & | bt | ) | const
| virtual

Encode subjectPublicKey part of subjectPublicKeyInfo.

Parameters

  bt | BufferedTransformation object

DEREncodePublicKey() encodes the subjectPublicKey part of subjectPublicKeyInfo, without the BIT STRING header.

See also
  DEREncodeAlgorithmParameters

Implements X509PublicKey.

Definition at line 798 of file xed25519.cpp.

## ◆ BERDecodeAndCheckAlgorithmID()

void ed25519PublicKey::BERDecodeAndCheckAlgorithmID | ( | BufferedTransformation & | bt | ) |

Determine if OID is valid for this object.

BERDecodeAndCheckAlgorithmID() parses the OID from `bt` and determines if it valid for this object. The problem in practice is there are multiple OIDs available to denote curve25519 operations. The OIDs include an old GNU OID used by SSH, OIDs specified in draft-josefsson-pkix-newcurves, and OIDs specified in draft-ietf-curdle-pkix.

By default BERDecodeAndCheckAlgorithmID() accepts an OID set by the user, `ASN1::curve25519()` and `ASN1::Ed25519()`. `ASN1::curve25519()` is generic and says "this key is valid for curve25519 operations". `ASN1::Ed25519()` is specific and says "this key is valid for ed25519 signing."

Definition at line 738 of file xed25519.cpp.

## ◆ Validate()

bool ed25519PublicKey::Validate | ( | RandomNumberGenerator & | rng,
|  | unsigned int | level
| ) |  | const
| virtual

Check this object for errors.

Parameters

  rng | a RandomNumberGenerator for objects which use randomized testing
  level | the level of thoroughness

Returns
  true if the tests succeed, false otherwise

There are four levels of thoroughness:

- 0 - using this object won't cause a crash or exception
- 1 - this object will probably function, and encrypt, sign, other operations correctly
- 2 - ensure this object will function correctly, and perform reasonable security checks
- 3 - perform reasonable security checks, and do checks that may take a long time

Level 0 does not require a RandomNumberGenerator. A NullRNG() can be used for level 0. Level 1 may not check for weak keys and such. Levels 2 and 3 are recommended.

See also
  ThrowIfInvalid()

Implements CryptoMaterial.

Definition at line 824 of file xed25519.cpp.

## ◆ GetVoidValue()

bool ed25519PublicKey::GetVoidValue | ( | const char * | name,
|  | const std::type_info & | valueType,
|  | void * | pValue
| ) |  | const
| virtual

Get a named value.

Parameters

  name | the name of the object or value to retrieve
  valueType | reference to a variable that receives the value
  pValue | void pointer to a variable that receives the value

Returns
  true if the value was retrieved, false otherwise

GetVoidValue() retrieves the value of name if it exists.

Note
  GetVoidValue() is an internal function and should be implemented by derived classes. Users should use one of the other functions instead.

See also
  GetValue(), GetValueWithDefault(), GetIntValue(), GetIntValueWithDefault(), GetRequiredParameter() and GetRequiredIntParameter()

Implements NameValuePairs.

Definition at line 701 of file xed25519.cpp.

## ◆ AssignFrom()

void ed25519PublicKey::AssignFrom | ( | const NameValuePairs & | source | ) |
| virtual

Assign values to this object.

This function can be used to create a public key from a private key.

Implements CryptoMaterial.

Definition at line 723 of file xed25519.cpp.

## ◆ GetPublicKeyBytePtr()

const byte* ed25519PublicKey::GetPublicKeyBytePtr | ( |  | ) | const
| inline

Retrieve public key byte array.

Returns
  the public key byte array

GetPublicKeyBytePtr() is used by signing code to call ed25519_sign.

Definition at line 689 of file xed25519.h.

## Member Data Documentation

## ◆ PUBLIC_KEYLENGTH

const int ed25519PublicKey::PUBLIC_KEYLENGTH = 32
| static

Size of the public key.

PUBLIC_KEYLENGTH is the size of the public key, in bytes.

Definition at line 629 of file xed25519.h.

The documentation for this struct was generated from the following files:

- xed25519.h
- xed25519.cpp